﻿package object3ds 
{
	import adobe.utils.CustomActions;
	import flash.events.Event
	import flash.events.EventDispatcher;	
	import object3ds.factoryObject3d.FactoryObject3d;
	import object3ds.flashGUI.Object3dConPane;
	import object3ds.flashGUI.AnimeConPane;
	import org.papervision3d.objects.DisplayObject3D;
	import org.papervision3d.objects.parsers.DAE;
	
	/**
	 * ...
	 * @author hagiwara
	 */
	public class ControllObject3d extends EventDispatcher
	{	
		private var _object3d:FactoryObject3d; //シーン全体のDAEファイルを読み込むために作成
		private var _controllObjects:Array; //操作するためのDisplayObject3Dの集合体。できれば1次元配列管理
		private var _object3dConPane:Object3dConPane;
		private var _animeConPane:AnimeConPane;
		
		//シングルトンInstance
		private static var $instance:ControllObject3d; 
		
		public function ControllObject3d(singletonEnforcer:SingletonEnforcer) 
		{
			this._object3d = new VF25(true, "VF25", true) as FactoryObject3d;
		}
		
		public static function getInstance():ControllObject3d
		{
			if (ControllObject3d.$instance == null) {
				$instance = new ControllObject3d(new SingletonEnforcer());
			}
			return ControllObject3d.$instance;
		}
		
		public function createObject3d():void {
			this._object3d.addEventListener(FactoryObject3d.COMPLETE_CREATE_OBJECT3D, completeCreatObject);
			this._object3d.createObject3d();
		}
		
		private function completeCreatObject(event:Event):void
		{
			_controllObjects = new Array();
			
			//body
			_controllObjects['VF25'] = _object3d;
			_controllObjects['chest'] = _object3d.getChildByName("COLLADA_Scene").getChildByName("chest");
			_controllObjects['back'] = _controllObjects['chest'].getChildByName("back");
			_controllObjects['leftSide'] = _controllObjects['chest'].getChildByName("leftSide");
			_controllObjects['rightSide'] = _controllObjects['leftSide'].getChildByName("rightSide");
			_controllObjects['cockpit'] = _controllObjects['leftSide'].getChildByName("cockpit");
			_controllObjects['nose'] = _controllObjects['cockpit'].getChildByName("nose");
			_controllObjects['waist'] = _controllObjects['cockpit'].getChildByName("waist");
			
			//head
			_controllObjects['neck'] = _controllObjects['chest'].getChildByName("neck");
			_controllObjects['head'] = _controllObjects['neck'].getChildByName("head");
			_controllObjects['leftAntenna'] = _controllObjects['head'].getChildByName("leftAntenna");
			_controllObjects['rightAntenna'] = _controllObjects['leftAntenna'].getChildByName("rightAntenna");
			
			//leftWing
			_controllObjects['leftWing'] = _controllObjects['back'].getChildByName("leftWing");
			_controllObjects['leftWing1'] = _controllObjects['leftWing'].getChildByName("leftWing1");
			_controllObjects['leftWing2'] = _controllObjects['leftWing1'].getChildByName("leftWing2");
			_controllObjects['leftWing3'] = _controllObjects['leftWing1'].getChildByName("leftWing3");
			_controllObjects['leftWing4'] = _controllObjects['leftWing3'].getChildByName("leftWing4");
			
			//rightWing
			_controllObjects['rightWing'] = _controllObjects['back'].getChildByName("rightWing");
			_controllObjects['rightWing1'] = _controllObjects['rightWing'].getChildByName("rightWing1");
			_controllObjects['rightWing2'] = _controllObjects['rightWing1'].getChildByName("rightWing2");
			_controllObjects['rightWing3'] = _controllObjects['rightWing1'].getChildByName("rightWing3");
			_controllObjects['rightWing4'] = _controllObjects['rightWing3'].getChildByName("rightWing4");
			
			//leftArm
			_controllObjects['leftShoulder'] = _controllObjects['chest'].getChildByName("leftShoulder");
			_controllObjects['innerLeftShoulder'] = _controllObjects['leftShoulder'].getChildByName("innerLeftShoulder");
			_controllObjects['middleLeftShoulder'] = _controllObjects['innerLeftShoulder'].getChildByName("middleLeftShoulder");
			_controllObjects['outerLeftShoulder'] = _controllObjects['middleLeftShoulder'].getChildByName("outerLeftShoulder");
			_controllObjects['leftArm'] = _controllObjects['outerLeftShoulder'].getChildByName("leftArm");
			_controllObjects['leftPalm'] = _controllObjects['leftArm'].getChildByName("leftPalm");
			_controllObjects['tail'] = _controllObjects['leftArm'].getChildByName("tail");
			
			//rightArm
			_controllObjects['rightShoulder'] = _controllObjects['chest'].getChildByName("rightShoulder");
			_controllObjects['innerRightShoulder'] = _controllObjects['rightShoulder'].getChildByName("innerRightShoulder");
			_controllObjects['middleRightShoulder'] = _controllObjects['innerRightShoulder'].getChildByName("middleRightShoulder");
			_controllObjects['outerRightShoulder'] = _controllObjects['middleRightShoulder'].getChildByName("outerRightShoulder");
			_controllObjects['rightArm'] = _controllObjects['outerRightShoulder'].getChildByName("rightArm");
			_controllObjects['rightPalm'] = _controllObjects['rightArm'].getChildByName("rightPalm");//パー
			_controllObjects['weapon'] = _controllObjects['rightArm'].getChildByName("weapon");
			_controllObjects['rifle'] = _controllObjects['weapon'].getChildByName("rifle");
			_controllObjects['rightPalm2'] = _controllObjects['rightArm'].getChildByName("rightPalm2");//グー
			_controllObjects['rightPalm2'].visible = false;
			
			//leftLeg
			_controllObjects['leftLeg'] = _controllObjects['waist'].getChildByName("leftLeg");
			_controllObjects['leftThigh'] = _controllObjects['leftLeg'].getChildByName("leftThigh");
			_controllObjects['leftPetticoat'] = _controllObjects['leftThigh'].getChildByName("leftPetticoat");
			_controllObjects['leftHamstring'] = _controllObjects['leftThigh'].getChildByName("leftHamstring");
			_controllObjects['leftShin'] = _controllObjects['leftHamstring'].getChildByName("leftShin");
			_controllObjects['leftKnee'] = _controllObjects['leftShin'].getChildByName("leftKnee");
			_controllObjects['leftToe'] = _controllObjects['leftShin'].getChildByName("leftToe");
			_controllObjects['leftHeel'] = _controllObjects['leftShin'].getChildByName("leftHeel");
			_controllObjects['leftLegWing'] = _controllObjects['leftShin'].getChildByName("leftLegWing");
			
			//rightLeg
			_controllObjects['rightLeg'] = _controllObjects['waist'].getChildByName("rightLeg");
			_controllObjects['rightThigh'] = _controllObjects['rightLeg'].getChildByName("rightThigh");
			_controllObjects['rightPetticoat'] = _controllObjects['rightThigh'].getChildByName("rightPetticoat");
			_controllObjects['rightHamstring'] = _controllObjects['rightThigh'].getChildByName("rightHamstring");
			_controllObjects['rightShin'] = _controllObjects['rightHamstring'].getChildByName("rightShin");
			_controllObjects['rightKnee'] = _controllObjects['rightShin'].getChildByName("rightKnee");
			_controllObjects['rightToe'] = _controllObjects['rightShin'].getChildByName("rightToe");
			_controllObjects['rightHeel'] = _controllObjects['rightShin'].getChildByName("rightHeel");
			_controllObjects['rightLegWing'] = _controllObjects['rightShin'].getChildByName("rightLegWing");
			
			
			for each(var VF25parts:DisplayObject3D in _controllObjects) {
				trace(VF25parts, ", rotationX:", Math.round(VF25parts.rotationX), ", rotationY:", Math.round(VF25parts.rotationY), ", rotationZ:", Math.round(VF25parts.rotationZ)
					,", localRotationX:",VF25parts.localRotationX,", localRotationY:",VF25parts.localRotationY,", localRotationZ:",VF25parts.localRotationZ	);
			}
			
			_object3dConPane = new Object3dConPane(_object3d);
			_animeConPane = new AnimeConPane(_object3d, _controllObjects);
			this.dispatchEvent(new Event(FactoryObject3d.COMPLETE_CREATE_OBJECT3D));
		}
		
		/*以下セッターとゲッター*/
		public function get object3d():FactoryObject3d
		{
			return this._object3d;
		}
		
		public function get object3dConPane():Object3dConPane
		{
			return this._object3dConPane;
		}
		
		public function get animeConPane():AnimeConPane
		{
			return this._animeConPane;
		}
		
		public function get controllObject():Array
		{
			return this._controllObjects;
		}
		
	}

}

class SingletonEnforcer {
	//シングルトン用のクラス
}